(function () {
  try {
    return angular.module('bonitasoft.ui.widgets');
  } catch(e) {
    return angular.module('bonitasoft.ui.widgets', []);
  }
})().directive('customDateTimePicker', function() {
    return {
      controllerAs: 'ctrl',
      controller: /**
 * The controller is a JavaScript function that augments the AngularJS scope and exposes functions that can be used in the custom widget template
 * 
 * Custom widget properties defined on the right can be used as variables in a controller with $scope.properties
 * To use AngularJS standard services, you must declare them in the main function arguments.
 * 
 * You can leave the controller empty if you do not need it.
 */
function ($scope, $log, widgetNameFactory, $element, $timeout) {
   'use strict';

    this.name = widgetNameFactory.getName('customDateTimePicker');

    this.getTimeZone= function () {
        if ($scope.properties.timeMode === "ABSOLUTE" || $scope.properties.timeMode === "DAY")
          return "UTC";
        // case TIMEZONE
        return null;  
    }
    this.showTimePicker = function () {
        return  ($scope.properties.timeMode !== "DAY")
    }
    
    // if($scope.properties.value === undefined) {
    //    $log.info("timer initial property undefined....setting to current time by default");
    //    $scope.properties.value =  new Date();
    // }
    
    // bypassing if allready set
    // if(!$scope.properties.value){
    //    
    //    $log.info("timer initial value not set so setting to current time");
    //    $scope.properties.value =  new Date();
    // } 
    if ($scope.properties.timeMode === "DAY" && $scope.properties.value)
    {
        // remove the HOUR
        $scope.properties.value.setUTCHours(0);
        $scope.properties.value.setUTCMinutes(0);
        $scope.properties.value.setUTCSeconds(0);
        $scope.properties.value.setUTCMilliseconds(0);
    }

    $scope.$watch('properties.value', function(value) {
          if ($scope.properties.timeMode === "DAY")
          {
              
            if ($scope.properties.value )
            {
                // remove the HOUR - THIS IS NOT WORKING
                $log.info("wath set UTC ["+$scope.properties.value+"] to 0 BUT NOT WORKING");
                $scope.properties.value.setUTCHours(0);
                $scope.properties.value.setUTCMinutes(0);
                $scope.properties.value.setUTCSeconds(0);
                $scope.properties.value.setUTCMilliseconds(0);
            }
          }
    });

    if( $scope.properties.placeholder === undefined )
        $scope.properties.placeholder = "yyyy-MM-dd";
 
    if( $scope.properties.dateFormat === undefined )
        $scope.properties.dateFormat = "yyyy-MM-dd";

    // $scope.showTimePicker = true;

    // $scope.toggleTimePicker = function () {
        
    //     $scope.showTimePicker = $scope.showTimePicker ? false : true;
    // };
    
    $scope.openTime = function () {
 
        $log.info('customDateTimePicker:: inside openTime from Time click');
        angular.element(document.querySelector('#timePickerCtrl')).triggerHandler('click');
    };

    
    $scope.openDate = function () {
 
        $log.info('customDateTimePicker:: inside openDate from Date click');
 
        angular.element(document.querySelector('#datePickerCtrl')).triggerHandler('click');
    };

  if (!$scope.properties.isBound('value')) {
      
    $log.error('the customDateTimePicker property named "value" need to be bound to a variable');
  }
},
      template: '<div ng-class="{\n    \'form-horizontal\': properties.labelPosition === \'left\' && !properties.labelHidden,\n    \'row\': properties.labelPosition === \'top\' && !properties.labelHidden || properties.labelHidden\n    }">\n    <div class="form-group">\n        <label\n                ng-if="!properties.labelHidden"\n                ng-class="{ \'control-label--required\': properties.required }"\n                class="control-label col-xs-{{ !properties.labelHidden && properties.labelPosition === \'left\' ? properties.labelWidth : 12 }}">\n                {{ properties.timepickerlabel | uiTranslate }}\n        </label>\n            \n        <div\n            class="col-xs-{{ 12 - (!properties.labelHidden && properties.labelPosition === \'left\' ? properties.labelWidth : 0) }}">\n            <p class="input-group">\n                <input class="form-control"\n                       id="datePickerCtrl"\n                       name="{{ctrl.name}}"\n                       type="text"\n                       size="6"\n                       placeholder="{{ properties.placeholder | uiTranslate }}"\n                       ng-model = "properties.value"\n                       ng-readonly = "properties.readOnly"\n                       ng-required = "properties.required"\n                       bs-datepicker\n                       data-timezone={{ctrl.getTimeZone()}}\n                       data-data-type="number"\n                       data-container="body"\n                       data-autoclose="1"\n                       data-use-native = "true"\n                       data-date-format = "{{properties.dateFormat | uiTranslate}}"\n                       data-time-format = "HH:mm"\n                       data-trigger="click"\n                       onkeydown="return true">\n                <span class="input-group-btn">\n                    <button type="button" class="btn btn-default"\n                            ng-click="openDate()"\n                            ng-disabled="properties.readOnly">\n                        <i class="glyphicon glyphicon-calendar"></i>\n                    </button>\n                </span>                       \n            </p>\n            <div ng-messages="$form[ctrl.name].$dirty && $form[ctrl.name].$error "\n                 ng-messages-include="forms-generic-errors.html" role="alert"></div>\n        </div>\n    </div>    \n     <div class="form-group" ng-show="ctrl.showTimePicker()">\n          \n        <div\n            class="col-xs-{{ 12 - (!properties.labelHidden && properties.labelPosition === \'left\' ? properties.labelWidth : 0) }}">     \n            <p class="input-group">\n                       <input class="form-control"\n                       name="{{ctrl.name}}"\n                       id = "timePickerCtrl"\n                       type="text"\n                       size="6"\n                       placeholder="{{ properties.placeholder | uiTranslate }}"\n                       ng-model="properties.value"\n                       ng-readonly="properties.readOnly"\n                       ng-required="properties.required"\n                       bs-timepicker\n                       data-timezone={{ctrl.getTimeZone()}}\n                       data-container="body"\n                       data-minute-step="1"\n                       data-autoclose="1"\n                       data-use-native = "true"\n                       data-time-format = "HH:mm"\n                       data-trigger="click"                 \n                       onkeydown="return true">\n                <span class="input-group-btn">\n                    <button type="button" class="form-control"\n                            id = "timePickerButton"\n                            ng-click="openTime()"\n                            ng-disabled="properties.readOnly">\n                        <i class="glyphicon glyphicon-hourglass"></i>\n                    </button>\n                </span>\n            </p>            \n            <div ng-messages="$form[ctrl.name].$dirty && $form[ctrl.name].$error "\n                 ng-messages-include="forms-generic-errors.html" role="alert">\n            </div>        \n	 </div>	\n	</div>        \n</div>'
    };
  });
